Build Improvements (#4884)

* Use AppGroupId from Info.plists instead of hardcoded constant

* Update script, ci & Makefile

* Update Cocoapods to 1.9.3

* Split android builds using ABI filters

* Update Fastlane deps & build scripts

* Update CI to use latests scripts

* Display app version & build number in select server screen

* Make generate scripts compatible with node < 12

* Build scripts

* add build script to package.json

* Update to use bundler 2.1.4 and CI with Xcode 12

* Fix script name for build:ios-unsigned

* Fix RN iOS scripts

* Update CI pods-dependencies step

* Add pipefail to android executor

* Update Fastlane

* Fix type in postinstall script

* update android executor and set TERM

* Fix S3 bucket name variable

* Apply suggestions from code review

Co-authored-by: Miguel Alatzar <migbot@users.noreply.github.com>

* Fix master unit tests

* use requireActual in jest setup

* Jest setup to use react instead of React

Co-authored-by: Miguel Alatzar <migbot@users.noreply.github.com>
This commit is contained in:
Elias Nahum
2020-10-15 22:09:36 -03:00
committed by GitHub
parent 57d60649f8
commit 30d4aa2a3e
63 changed files with 586 additions and 674 deletions

97
scripts/build.sh Executable file
View File

@@ -0,0 +1,97 @@
#!/bin/sh
function execute() {
cd fastlane && NODE_ENV=production bundle exec fastlane $1 $2
}
function apk() {
case $1 in
unsigned)
echo "Building Android unsigned app"
setup android
execute android unsigned
;;
*)
echo "Building Android app"
setup android
execute android build
esac
}
function ipa() {
case $1 in
unsigned)
echo "Building iOS unsigned app"
setup ios
execute ios unsigned
;;
simulator)
echo "Building unsigned x86_64 iOS app for iPhone simulator"
setup ios
execute ios simulator
;;
*)
echo "Building iOS app"
setup ios
execute ios build
esac
}
function setup() {
if [[ -z "$SKIP_SETUP" ]]; then
npm run clean || exit 1
npm install --ignore-scripts || exit 1
npx patch-package || exit 1
if [[ "$1" == "ios"* ]]; then
echo "Installing Gems"
npm run ios-gems &> /dev/null || exit 1
echo "Getting Cocoapods dependencies"
npm run pod-install || exit 1
fi
ASSETS=$(node scripts/generate-assets.js)
if [ -z "$ASSETS" ]; then
echo "Error Generating app assets"
exit 1
else
echo "Generating app assets"
fi
echo "Installing Fastane"
if !gem list bundler -i --version 2.1.4 > /dev/null 2>&1; then
gem install bundler --versio 2.1.4
fi
cd fastlane && bundle install && cd .. || exit 1
fi
if [ "$1" = "android" ]; then
./node_modules/.bin/jetify
fi
}
case $1 in
apk)
apk $2
;;
ipa)
if [[ "$OSTYPE" == "darwin"* ]]; then
ipa $2
else
echo "You need a MacOS to build the iOS mobile app"
exit 1
fi
;;
*)
echo "Build the mobile app for Android or iOS
Usage: build.sh <type> [options]
Type:
apk Builds Android APK(s)
ipa Builds iOS IPA
Options:
apk: unsigned
ipa: unsigned or simulator"
;;
esac

11
scripts/clean.sh Executable file
View File

@@ -0,0 +1,11 @@
#!/bin/sh
echo Cleaning started
rm -rf ios/Pods
rm -rf node_modules
rm -rf dist
rm -rf ios/build
rm -rf android/app/build
echo Cleanup finished

View File

@@ -4,6 +4,7 @@
/* eslint-disable no-console */
const fs = require('fs');
const fsPath = require('path');
// Takes the files in rootA/path, overwrites or merges them with the corresponding file in rootB/path, and places the
// resulting file in dest/path. JSON files that exist in both places are shallowly (TODO maybe deeply) merged and all
@@ -13,7 +14,7 @@ function leftMergeDirs(rootA, rootB, dest, path) {
const pathB = rootB + path;
try {
fs.mkdirSync(dest + path);
fs.mkdirSync(dest + path, {recursive: true});
} catch (e) {
if (e.code !== 'EEXIST') {
console.error('Failed to create destination dir ' + dest + path);
@@ -83,6 +84,25 @@ function leftMergeDirs(rootA, rootB, dest, path) {
}
}
const rmdir = (path) => {
const list = fs.readdirSync(path);
for (let i = 0; i < list.length; i++) {
const filename = fsPath.join(path, list[i]);
const stat = fs.statSync(filename);
if (stat.isDirectory()) {
rmdir(filename);
} else {
fs.unlinkSync(filename);
}
}
fs.rmdirSync(path);
};
if (fs.existsSync('dist')) {
rmdir('dist');
}
// Assumes dist/assets exists and is empty
leftMergeDirs('assets/base/', 'assets/override/', 'dist/assets/', '');
/* eslint-enable no-console */

19
scripts/postinstall.sh Executable file
View File

@@ -0,0 +1,19 @@
#!/bin/sh
if [[ "$OSTYPE" == "darwin"* ]]; then
if !gem list bundler -i --version 2.1.4 > /dev/null 2>&1; then
gem install bundler --version 2.1.4
fi
echo "Installing Gems"
npm run ios-gems &> /dev/null
echo "Getting Cocoapods dependencies"
npm run pod-install &> /dev/null
fi
ASSETS=$(node scripts/generate-assets.js)
if [ -z "$ASSETS" ]; then
echo "Error Generating app assets"
exit 1
else
echo "Generating app assets"
fi